# Transactions

## Add transaction tip

> Add a tip amount to an existing captured transaction identified by the transaction ID.

```json
{"openapi":"3.0.1","info":{"title":"Transaction Service API","version":"2.0"},"paths":{"/rest/v2/transactions/{id}":{"put":{"tags":["Transactions"],"summary":"Add transaction tip","description":"Add a tip amount to an existing captured transaction identified by the transaction ID.","operationId":"adjustTip","parameters":[{"name":"api-key","in":"header","description":"An access API key issued to you by Xplor Pay.","required":true,"schema":{"type":"string"}},{"name":"id","in":"path","description":"A unique identifier for the transaction returned by the Capture a Transaction endpoint.","required":true}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/TipRequest"}}},"required":true},"responses":{"200":{"description":"Successful Transaction","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ClearentTransactionResponsePayload"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ClearentTransactionResponsePayload"}}}},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}}}},"402":{"description":"Business Exception","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}}}},"500":{"description":"Internal server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}}}}}}}},"components":{"schemas":{"TipRequest":{"required":["tip-amount"],"type":"object","properties":{"tip-amount":{"type":"string","description":"The value of the tip to be added to the transaction (in decimal format). For example, \"0.08\" for 8 cents."}}},"ClearentTransactionResponsePayload":{"type":"object","properties":{"transaction":{"$ref":"#/components/schemas/transaction"},"payloadType":{"type":"string","description":"Type of payload returned in the response.","xml":{"name":"type","attribute":true}}},"description":"payload","xml":{"name":"payload"}},"transaction":{"type":"object","properties":{"amount":{"type":"string","description":"Total value associated with the transaction."},"currency":{"type":"string","description":"Currency used for the transaction."},"id":{"type":"string","description":"Unique transaction ID."},"invoice":{"type":"string","description":"Invoice number associated with the transaction."},"description":{"type":"string","description":"Description of the transaction."},"comments":{"type":"string","description":"Comments associated with the transaction."},"serverId":{"type":"string","deprecated":true},"created":{"type":"string","description":"Date and time when the transaction was created."},"type":{"type":"string","description":"Identifies the transaction type.","enum":["AUTH","SALE","REFUND","VOID","CAPTURE","FORCED SALE","CARD INQUIRY"]},"result":{"type":"string","description":"Result of the transaction. For example, APPROVED.","enum":["APPROVED","DECLINED","ERROR"]},"billing":{"$ref":"#/components/schemas/Address"},"shipping":{"$ref":"#/components/schemas/Address"},"card":{"type":"string","description":"Card number used for the transaction."},"csc":{"type":"string","description":"Card Security Code used."},"cvm":{"type":"string","description":"Cardholder Verification Method used.","enum":["NON (None)","MSG(Manual Signature)","OFC(Offline Pin in the Clear)","PIN(Online Pin)","OFE(Offline Encrypted Pin)"]},"action":{"$ref":"#/components/schemas/action"},"authorization-code":{"type":"string","description":"Code indicating the transaction authorization."},"avs-result-code":{"type":"string","description":"Result code from Address Verification Service.","enum":["X","Y","A","W","Z","N","U","R","S","G"]},"avs-result-code-description":{"type":"string","description":"Description of the AVS result."},"csc-result-code":{"type":"string","description":"Result code from CSC verification.","enum":["M","N","P","S","U","X"]},"csc-result-code-description":{"type":"string","description":"Description of the CSC result."},"tip-adjusted-amount":{"type":"string","description":"Amount of the adjusted tip."},"avs-street":{"type":"string","description":"Street used in AVS check."},"avs-zip":{"type":"string","description":"ZIP code used in AVS check."},"token-description":{"type":"string","description":"Description of the token created."},"original-amount":{"type":"string","description":"Original amount before adjustments."},"tip-amount":{"type":"string","description":"Tip amount included in the transaction."},"ref-id":{"type":"string","description":"Reference ID for the transaction."},"entry-method":{"type":"string","description":"Method used to enter payment data of the transaction. For example, Swipe/Manual."},"first-recurring-transaction":{"type":"string","description":"Indicates whether this is the first recurring transaction."},"batch-string-id":{"type":"string","description":"Identifies the settlement batch ID."},"order-id":{"type":"string","description":"Order id passed in with the transaction."},"purchase-order":{"type":"string","description":"Purchase order number."},"customer-id":{"type":"string","description":"Customer id passed in with the transaction."},"email-address":{"type":"string","description":"Email address associated with the transaction."},"display-message":{"type":"string","description":"Displayable message about transaction result."},"result-code":{"type":"string","description":"Result code associated with transaction result."},"billing-is-shipping":{"type":"string","description":"Indicates if billing and shipping addresses are the same."},"tip-adjusted":{"type":"string","description":"Indicates if the tip was adjusted."},"exp-date":{"type":"string","description":"Expiration date of the card."},"client-ip":{"type":"string","description":"IP address of the client initiating the transaction."},"voided":{"type":"string","description":"Indicates if the transaction was voided."},"pending":{"type":"string","description":"Indicates if the transaction is pending."},"voided-auth":{"type":"string","description":"Indicates if the authorization was voided."},"settled":{"type":"string","description":"Indicates if the transaction has been settled."},"status":{"type":"string","description":"Status of the transaction. For example, approved."},"emv-data":{"type":"string","description":"Raw EMV data string."},"key-serial-number":{"type":"string","description":"Serial number of the encryption key used."},"emv-entry-method":{"type":"string","description":"Method used to enter EMV data.","enum":["EMV_DIP","EMV_CONTACTLESS","EMV_FALLBACK_SWIPE","EMV_FALLBACK_NONTECH"]},"software-type":{"type":"string","description":"Type of software used for the transaction."},"customer-first-name":{"type":"string","description":"First name of the customer."},"customer-last-name":{"type":"string","description":"Last name of the customer."},"plan-name":{"type":"string","description":"Name of the payment plan used."},"card-type":{"type":"string","description":"Type of card used. For example, VISA."},"contactless":{"type":"string","description":"Indicates if contactless payment was used."},"contactless-device":{"type":"string","description":"Indicates if a contactless device was used."},"sales-tax-type":{"type":"string","description":"Type of sales tax applied."},"sales-tax-amount":{"type":"string","description":"Amount of sales tax applied."},"add-tax-to-amount":{"type":"boolean","description":"Indicates if tax was added to the transaction amount."},"emv-data-response":{"type":"string","description":"Response data from EMV processing."},"emv":{"$ref":"#/components/schemas/emv"},"signature-base-64-image":{"type":"string","description":"Base64-encoded image of the signature."},"last-four":{"type":"string","description":"Last four digits of the card number."},"check-field-duplicate":{"type":"boolean","description":"Indicates if a duplicate check was performed."},"service-fee":{"type":"string","description":"Service fee applied to the transaction"},"base-amount":{"type":"string","description":"Base amount before taxes and fees."},"platform-fees":{"type":"array","description":"List of platform fees applied.","items":{"$ref":"#/components/schemas/platform-fee"}},"merchant-id":{"type":"string","description":"Identifier for the merchant."},"terminal-id":{"type":"string","description":"Identifier for the terminal used."},"surcharge-applied":{"type":"boolean","description":"Indicates if a surcharge was applied."},"level3":{"$ref":"#/components/schemas/level3"},"partial-authorization":{"type":"boolean","description":"Indicates if partial authorization was allowed."},"partial-approved":{"type":"boolean","description":"Indicates if the transaction was partially approved."},"additional-amounts":{"type":"array","description":"List of additional amounts applied to the transaction.","xml":{"wrapped":true},"items":{"$ref":"#/components/schemas/additional-amount"}},"secure3d-eci":{"type":"string","description":"Electronic Commerce Indicator for 3D Secure."},"secure3d-result-code":{"type":"string","description":"Result code from 3D Secure authentication."},"total-amount":{"type":"string","description":"Total amount including all charges."},"processing-party-reference":{"type":"string","description":"Reference ID from the processing party."},"original-processing-party-reference":{"type":"string","description":"Reference of the original transaction assigned by the processing party."},"external-transaction-reference":{"type":"string","description":"External reference ID for the transaction."},"funding-reference":{"type":"string","description":"Reference for the funding transaction."},"token-id":{"type":"string","description":"Identifier of the payment token."},"network-transaction-reference":{"type":"string","description":"Reference ID from the payment network for the transaction."},"create-token":{"type":"boolean","description":"Indicates if a token should be created for the transaction."},"moto":{"type":"boolean","description":"Indicates whether the transaction is MOTO."},"issuer_id":{"type":"string","description":"Identifier for the card issuer."},"digital-wallet-type":{"type":"string","description":"Type of digital wallet used. For example, GOOGLE."}},"description":"Contains all details related to the authorized transaction.","xml":{"name":"transaction"}},"Address":{"type":"object","properties":{"company":{"type":"string","description":"The company name for the billing address."},"street":{"type":"string","description":"The primary street address."},"street2":{"type":"string","description":"Additional street information. For example, suite."},"city":{"type":"string","description":"The billing city."},"state":{"type":"string","description":"The state of the billing address."},"zip":{"type":"string","description":"The postal code of billing address."},"country":{"type":"string","description":"The country of the billing address."},"phone":{"type":"string","description":"The contact phone number."},"first-name":{"type":"string","description":"First name of the contact."},"last-name":{"type":"string","description":"Last name of the contact."},"from-zip":{"type":"string","description":"The originating ZIP code."}},"description":"Contains shipping address and contact information.","xml":{"name":"clearent-address"}},"action":{"type":"object","properties":{"url":{"type":"string","description":"URL endpoint used for the transaction."},"method":{"type":"string","description":"Method used for the transaction. For example, POST, GET."},"type":{"type":"string","description":"Type of transaction. For example, SALE."},"environment":{"type":"string","description":"Environment in which the transaction was processed. For example, production, test."},"locale":{"type":"string","description":"Locale setting used during the transaction."},"data":{"type":"object","additionalProperties":{"type":"string","description":"Additional data properties related to the action."},"description":"Additional data properties related to the action."},"payment-method-type":{"type":"string","description":"Type of payment method used. For example, card, wallet."},"sub-type":{"type":"string","description":"Sub-category of the transaction type."},"client-key":{"type":"string","description":"Key identifying the client initiating the transaction."},"qr-code-data":{"type":"string","description":"Data encoded in the QR code for the transaction."}},"description":"The transaction action performed.","xml":{"name":"action"}},"emv":{"type":"object","properties":{"application-name":{"type":"string","description":"The name of the EMV application used to process the transaction."},"application-id":{"type":"string","description":"The unique identifier of the application."},"terminal-verification-results":{"type":"string","description":"Results of terminal-level verification during the transaction."},"transaction-status-information":{"type":"string","description":"Status details that describes the processing state of the transaction."},"iad":{"type":"string","description":"IAD provided by the card issuer during the authorization."},"transaction-certificate":{"type":"string","description":"A certificate generated during the transaction processing."},"application-transaction-counter":{"type":"string","description":"A counter that increments with each transaction."}},"description":"EMV chip data related to the transaction.","xml":{"name":"emv"}},"platform-fee":{"type":"object","properties":{"fee-name":{"type":"string","description":"The name of the fee applied to the transaction.","enum":["DealManager","FillMyBook"]}},"description":"List of platform fees applied.","xml":{"name":"platform-fee"}},"level3":{"type":"object","properties":{"vat-tax-amount":{"type":"string","description":"The VAT amount applied to the transaction."},"vat-tax-rate":{"type":"string","description":"VAT tax rate applied to the transaction."},"order-date":{"type":"string","description":"The date when the order was created."},"customer-vat-registration-number":{"type":"string","description":"Cardholder's VAT registration number."},"summary-commodity-code":{"type":"string","description":"Code that identifies the type of service included in the transaction."},"discount-amount":{"type":"string","description":"Total discount amount."},"destination-country-code":{"type":"string","description":"The ISO country code of the destination."},"freight-amount":{"type":"string","description":"Freight charges."},"duty-amount":{"type":"string","description":"Duty amount applied."},"level3-items":{"$ref":"#/components/schemas/level3-items"}},"description":"Level 3 data for enhanced transaction details.","xml":{"name":"level3"}},"level3-items":{"type":"object","properties":{"level3-items":{"type":"array","items":{"$ref":"#/components/schemas/level3-item"}}},"description":"Level 3 line-item data for the transaction.","xml":{"name":"level3-items"}},"level3-item":{"type":"object","properties":{"item-description":{"type":"string","description":"Description of the item."},"item-commodity-code":{"type":"string","description":"Commodity code of the item."},"item-quantity":{"type":"string","description":"Quantity of items comprising of the order."},"item-unit-of-measure":{"type":"string","description":"The unit of measure of the purchased item as determined by ANSI X-12. Allowable Units of Measure and Codes."},"item-unit-cost":{"type":"string","description":"Per item cost for the order."},"item-product-code":{"type":"string","description":"Merchant identifiable code e.g., SKU or Model Number."},"item-tax-amount":{"type":"string","description":"Tax amount per item."},"item-tax-rate":{"type":"string","description":"Tax rate per item expressed as a decimal."},"item-discount":{"type":"string","description":"Discount amount applied per item."},"item-line-total":{"type":"string","description":"Total item count for the order."},"item-net-gross-ind":{"type":"string","description":"Indicated where the extended item amount is included in the tax. Can either be Yes (\"Y\") or No (\"N\") but should be passed as \"N\"."},"item-discount-rate":{"type":"string","description":"Discount rate applied per item expressed as a decimal."}},"description":"Level 3 line-item data for the transaction.","xml":{"name":"level3-item"}},"additional-amount":{"type":"object","properties":{"amount":{"type":"string","description":"Amount of transaction."},"account-type":{"type":"string","description":"Account type of transaction."},"amount-type":{"type":"string","description":"Refers to amount type of transaction."}},"description":"List of additional amounts applied to the transaction.","xml":{"name":"additional-amount"}},"ErrorPayloadResponsePayload":{"type":"object","properties":{"error":{"$ref":"#/components/schemas/ErrorPayload"},"payloadType":{"type":"string","description":"Type of payload returned in the response.","xml":{"name":"type","attribute":true}}},"description":"Payload","xml":{"name":"payload"}},"ErrorPayload":{"type":"object","properties":{"error-message":{"type":"string","description":"Describes the reason for the error."},"result-code":{"type":"string","description":"Numeric code that identifies the type of error returned by the request."},"time-stamp":{"type":"string","description":"Date and time when the error occurred, ISO 8601 format (UTC)."}},"xml":{"name":"error"}}}}}
```

## Void transaction

> Void transactions that are authorized, approved, or pending. Voided transactions are removed from the open batch and sent to the payment issuer. Transactions in closed batches cannot be voided.

```json
{"openapi":"3.0.1","info":{"title":"Transaction Service API","version":"2.0"},"paths":{"/rest/v2/transactions/void":{"post":{"tags":["Transactions"],"summary":"Void transaction","description":"Void transactions that are authorized, approved, or pending. Voided transactions are removed from the open batch and sent to the payment issuer. Transactions in closed batches cannot be voided.","operationId":"voidTransaction","parameters":[{"name":"api-key","in":"header","description":"An access API key issued to you by Xplor Pay.","required":true,"schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Request"}}},"required":true},"responses":{"200":{"description":"Successful Transaction","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ClearentTransactionResponsePayload"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ClearentTransactionResponsePayload"}}}},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}}}},"402":{"description":"Business Exception","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}}}},"500":{"description":"Internal server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}}}}}}}},"components":{"schemas":{"Request":{"required":["add-tax-to-amount","amount","secure3d","secure3d-directory-server-transaction-id","secure3d-eci","secure3d-platform","secure3d-protocol-version","type"],"type":"object","properties":{"amount":{"type":"string","description":"Total transaction amount.","enum":["range[-infinity, 12]"]},"type":{"type":"string","description":"Transaction type to process. For example, SALE, AUTH, REFUND.","enum":["AUTH,SALE,REFUND,VOID,CAPTURE,FORCED SALE,CARD INQUIRY"]},"card":{"type":"string","description":"Card number or payment token."},"secure3d":{"type":"string","description":"3‑D Secure cryptogram or CAVV (Cardholder Authentication Verification Value) provided by the 3DS provider.","enum":["range[-infinity, 40]"]},"secure3d-eci":{"type":"string","description":"Electronic Commerce Indicator from the issuer.","enum":["range[-infinity, 2]"]},"secure3d-platform":{"type":"string","description":"Name of the platform or provider used to perform 3‑D Secure (3DS) authentication."},"secure3d-directory-server-transaction-id":{"type":"string","description":"Directory Server Transaction ID that ties the authentication to the transaction authorization."},"secure3d-protocol-version":{"type":"string","description":"3‑D Secure protocol version used to ensure correct liability and routing."},"id":{"type":"string","description":"Transaction identifier from a previous sale or authorization.","enum":["range[-infinity, 19]"]},"billing":{"$ref":"#/components/schemas/Address"},"shipping":{"$ref":"#/components/schemas/Address"},"csc":{"type":"string","description":"Card security code."},"comments":{"type":"string","description":"Additional notes for the transaction.","enum":["range[-infinity, 225]"]},"cvm":{"type":"string","description":"Cardholder verification method.","enum":["NON (None),MSG(Manual Signature),OFC(Offline Pin in the Clear),PIN(Online Pin),OFE(Offline Encrypted Pin)"]},"exp-date":{"type":"string","description":"Card expiration date in MMyy format."},"track2-data":{"type":"string","description":"Clear-text Track 2 data."},"encrypted-track-data":{"type":"string","description":"Encrypted track data; requires track-format."},"track-format":{"type":"string","description":"Format of encrypted track data.","enum":["MAGTEK,IDTECH,DEJAVOO,PAX"]},"tip-amount":{"type":"string","description":"Tip amount applied to the transaction.","enum":["range[-infinity, 12]"]},"invoice":{"type":"string","description":"Merchant-defined invoice number."},"authorization-code":{"type":"string","description":"Authorization code for a forced sale obtained from an external processor.","enum":["range[-infinity, 255]"]},"purchase-order":{"type":"string","description":"Merchant-defined purchase order number.","enum":["range[-infinity, 255]"]},"email-receipt":{"type":"string","description":"Indicates whether to send an email receipt to the customer."},"email-address":{"type":"string","description":"The customer's email address.","enum":["range[-infinity, 255]"]},"customer-id":{"type":"string","description":"Merchant-defined customer identifier.","enum":["range[-infinity, 255]"]},"order-id":{"type":"string","description":"Merchant-defined order identifier.","enum":["range[-infinity, 255]"]},"description":{"type":"string","description":"Description of the transaction.","enum":["range[-infinity, 255]"]},"client-ip":{"type":"string","description":"IP address where the request originated.","enum":["range[-infinity, 255]"]},"billing-is-shipping":{"type":"string","description":"Indicates whether billing and shipping addresses match."},"create-token":{"type":"string","description":"Creates a payment token during the transaction."},"merchant-legacy-token":{"type":"string","description":"Indicates use of a legacy payment token."},"token-description":{"type":"string","description":"Description for the created token.","enum":["range[-infinity, 255]"]},"card-type":{"type":"string","description":"Card brand when creating a token.","enum":["VISA,MASTERCARD,AMERICAN EXPRESS,DISCOVER,DINERS CLUB,JCB"]},"emv-data":{"type":"string","description":"EMV transaction data payload."},"key-serial-number":{"type":"string","description":"Key serial number for EMV encryption."},"emv-entry-method":{"type":"string","description":"Method used to capture EMV data.","enum":["EMV_DIP,EMV_CONTACTLESS,EMV_FALLBACK_SWIPE,EMV_FALLBACK_NONTECH"]},"software-type":{"type":"string","description":"Identifies the integrating application.","enum":["range[-infinity, 255]"]},"software-type-version":{"type":"string","description":"Version of the integrating application."},"pin-data":{"type":"string","description":"Encrypted PIN data for PIN-based transactions."},"contactless":{"type":"string","description":"Indicates contactless usage (full EMV only)."},"contactless-device":{"type":"string","description":"Indicates contactless device usage (full EMV only)."},"sales-tax-amount":{"type":"string","description":"Sales tax amount applied to the transaction.","enum":["range[-infinity, 12]"]},"sales-tax-type":{"type":"string","description":"Sales tax classification.","enum":["LOCAL_SALES_TAX,TAX_EXEMPT"]},"check-field":{"type":"string","description":"Field used for duplicate transaction checks.","enum":["range[-infinity, 15]"]},"service-fee":{"type":"string","description":"Service fee applied to the transaction.","enum":["range[-infinity, 12]"]},"check-field-mid":{"type":"boolean","description":"Enables merchant-level duplicate validation for EMV."},"platform-fees":{"type":"array","description":"Platform fees applied to the merchant.","items":{"$ref":"#/components/schemas/platform-fee"}},"is-amex":{"type":"boolean","description":"Indicates whether the card is American Express."},"is-sp30":{"type":"boolean","description":"Indicates whether the transaction is processed on an SP30 terminal."},"card-inquiry":{"type":"boolean","description":"Validates the card before token storage."},"level3":{"$ref":"#/components/schemas/level3"},"partial-authorization":{"type":"boolean","description":"Allows partial approval when full amount is unavailable."},"add-tax-to-amount":{"type":"boolean","description":"Indicates whether to add tax to the transaction amount."}},"xml":{"name":"transaction"}},"Address":{"type":"object","properties":{"company":{"type":"string","description":"The company name for the billing address."},"street":{"type":"string","description":"The primary street address."},"street2":{"type":"string","description":"Additional street information. For example, suite."},"city":{"type":"string","description":"The billing city."},"state":{"type":"string","description":"The state of the billing address."},"zip":{"type":"string","description":"The postal code of billing address."},"country":{"type":"string","description":"The country of the billing address."},"phone":{"type":"string","description":"The contact phone number."},"first-name":{"type":"string","description":"First name of the contact."},"last-name":{"type":"string","description":"Last name of the contact."},"from-zip":{"type":"string","description":"The originating ZIP code."}},"description":"Contains shipping address and contact information.","xml":{"name":"clearent-address"}},"platform-fee":{"type":"object","properties":{"fee-name":{"type":"string","description":"The name of the fee applied to the transaction.","enum":["DealManager","FillMyBook"]}},"description":"List of platform fees applied.","xml":{"name":"platform-fee"}},"level3":{"type":"object","properties":{"vat-tax-amount":{"type":"string","description":"The VAT amount applied to the transaction."},"vat-tax-rate":{"type":"string","description":"VAT tax rate applied to the transaction."},"order-date":{"type":"string","description":"The date when the order was created."},"customer-vat-registration-number":{"type":"string","description":"Cardholder's VAT registration number."},"summary-commodity-code":{"type":"string","description":"Code that identifies the type of service included in the transaction."},"discount-amount":{"type":"string","description":"Total discount amount."},"destination-country-code":{"type":"string","description":"The ISO country code of the destination."},"freight-amount":{"type":"string","description":"Freight charges."},"duty-amount":{"type":"string","description":"Duty amount applied."},"level3-items":{"$ref":"#/components/schemas/level3-items"}},"description":"Level 3 data for enhanced transaction details.","xml":{"name":"level3"}},"level3-items":{"type":"object","properties":{"level3-items":{"type":"array","items":{"$ref":"#/components/schemas/level3-item"}}},"description":"Level 3 line-item data for the transaction.","xml":{"name":"level3-items"}},"level3-item":{"type":"object","properties":{"item-description":{"type":"string","description":"Description of the item."},"item-commodity-code":{"type":"string","description":"Commodity code of the item."},"item-quantity":{"type":"string","description":"Quantity of items comprising of the order."},"item-unit-of-measure":{"type":"string","description":"The unit of measure of the purchased item as determined by ANSI X-12. Allowable Units of Measure and Codes."},"item-unit-cost":{"type":"string","description":"Per item cost for the order."},"item-product-code":{"type":"string","description":"Merchant identifiable code e.g., SKU or Model Number."},"item-tax-amount":{"type":"string","description":"Tax amount per item."},"item-tax-rate":{"type":"string","description":"Tax rate per item expressed as a decimal."},"item-discount":{"type":"string","description":"Discount amount applied per item."},"item-line-total":{"type":"string","description":"Total item count for the order."},"item-net-gross-ind":{"type":"string","description":"Indicated where the extended item amount is included in the tax. Can either be Yes (\"Y\") or No (\"N\") but should be passed as \"N\"."},"item-discount-rate":{"type":"string","description":"Discount rate applied per item expressed as a decimal."}},"description":"Level 3 line-item data for the transaction.","xml":{"name":"level3-item"}},"ClearentTransactionResponsePayload":{"type":"object","properties":{"transaction":{"$ref":"#/components/schemas/transaction"},"payloadType":{"type":"string","description":"Type of payload returned in the response.","xml":{"name":"type","attribute":true}}},"description":"payload","xml":{"name":"payload"}},"transaction":{"type":"object","properties":{"amount":{"type":"string","description":"Total value associated with the transaction."},"currency":{"type":"string","description":"Currency used for the transaction."},"id":{"type":"string","description":"Unique transaction ID."},"invoice":{"type":"string","description":"Invoice number associated with the transaction."},"description":{"type":"string","description":"Description of the transaction."},"comments":{"type":"string","description":"Comments associated with the transaction."},"serverId":{"type":"string","deprecated":true},"created":{"type":"string","description":"Date and time when the transaction was created."},"type":{"type":"string","description":"Identifies the transaction type.","enum":["AUTH","SALE","REFUND","VOID","CAPTURE","FORCED SALE","CARD INQUIRY"]},"result":{"type":"string","description":"Result of the transaction. For example, APPROVED.","enum":["APPROVED","DECLINED","ERROR"]},"billing":{"$ref":"#/components/schemas/Address"},"shipping":{"$ref":"#/components/schemas/Address"},"card":{"type":"string","description":"Card number used for the transaction."},"csc":{"type":"string","description":"Card Security Code used."},"cvm":{"type":"string","description":"Cardholder Verification Method used.","enum":["NON (None)","MSG(Manual Signature)","OFC(Offline Pin in the Clear)","PIN(Online Pin)","OFE(Offline Encrypted Pin)"]},"action":{"$ref":"#/components/schemas/action"},"authorization-code":{"type":"string","description":"Code indicating the transaction authorization."},"avs-result-code":{"type":"string","description":"Result code from Address Verification Service.","enum":["X","Y","A","W","Z","N","U","R","S","G"]},"avs-result-code-description":{"type":"string","description":"Description of the AVS result."},"csc-result-code":{"type":"string","description":"Result code from CSC verification.","enum":["M","N","P","S","U","X"]},"csc-result-code-description":{"type":"string","description":"Description of the CSC result."},"tip-adjusted-amount":{"type":"string","description":"Amount of the adjusted tip."},"avs-street":{"type":"string","description":"Street used in AVS check."},"avs-zip":{"type":"string","description":"ZIP code used in AVS check."},"token-description":{"type":"string","description":"Description of the token created."},"original-amount":{"type":"string","description":"Original amount before adjustments."},"tip-amount":{"type":"string","description":"Tip amount included in the transaction."},"ref-id":{"type":"string","description":"Reference ID for the transaction."},"entry-method":{"type":"string","description":"Method used to enter payment data of the transaction. For example, Swipe/Manual."},"first-recurring-transaction":{"type":"string","description":"Indicates whether this is the first recurring transaction."},"batch-string-id":{"type":"string","description":"Identifies the settlement batch ID."},"order-id":{"type":"string","description":"Order id passed in with the transaction."},"purchase-order":{"type":"string","description":"Purchase order number."},"customer-id":{"type":"string","description":"Customer id passed in with the transaction."},"email-address":{"type":"string","description":"Email address associated with the transaction."},"display-message":{"type":"string","description":"Displayable message about transaction result."},"result-code":{"type":"string","description":"Result code associated with transaction result."},"billing-is-shipping":{"type":"string","description":"Indicates if billing and shipping addresses are the same."},"tip-adjusted":{"type":"string","description":"Indicates if the tip was adjusted."},"exp-date":{"type":"string","description":"Expiration date of the card."},"client-ip":{"type":"string","description":"IP address of the client initiating the transaction."},"voided":{"type":"string","description":"Indicates if the transaction was voided."},"pending":{"type":"string","description":"Indicates if the transaction is pending."},"voided-auth":{"type":"string","description":"Indicates if the authorization was voided."},"settled":{"type":"string","description":"Indicates if the transaction has been settled."},"status":{"type":"string","description":"Status of the transaction. For example, approved."},"emv-data":{"type":"string","description":"Raw EMV data string."},"key-serial-number":{"type":"string","description":"Serial number of the encryption key used."},"emv-entry-method":{"type":"string","description":"Method used to enter EMV data.","enum":["EMV_DIP","EMV_CONTACTLESS","EMV_FALLBACK_SWIPE","EMV_FALLBACK_NONTECH"]},"software-type":{"type":"string","description":"Type of software used for the transaction."},"customer-first-name":{"type":"string","description":"First name of the customer."},"customer-last-name":{"type":"string","description":"Last name of the customer."},"plan-name":{"type":"string","description":"Name of the payment plan used."},"card-type":{"type":"string","description":"Type of card used. For example, VISA."},"contactless":{"type":"string","description":"Indicates if contactless payment was used."},"contactless-device":{"type":"string","description":"Indicates if a contactless device was used."},"sales-tax-type":{"type":"string","description":"Type of sales tax applied."},"sales-tax-amount":{"type":"string","description":"Amount of sales tax applied."},"add-tax-to-amount":{"type":"boolean","description":"Indicates if tax was added to the transaction amount."},"emv-data-response":{"type":"string","description":"Response data from EMV processing."},"emv":{"$ref":"#/components/schemas/emv"},"signature-base-64-image":{"type":"string","description":"Base64-encoded image of the signature."},"last-four":{"type":"string","description":"Last four digits of the card number."},"check-field-duplicate":{"type":"boolean","description":"Indicates if a duplicate check was performed."},"service-fee":{"type":"string","description":"Service fee applied to the transaction"},"base-amount":{"type":"string","description":"Base amount before taxes and fees."},"platform-fees":{"type":"array","description":"List of platform fees applied.","items":{"$ref":"#/components/schemas/platform-fee"}},"merchant-id":{"type":"string","description":"Identifier for the merchant."},"terminal-id":{"type":"string","description":"Identifier for the terminal used."},"surcharge-applied":{"type":"boolean","description":"Indicates if a surcharge was applied."},"level3":{"$ref":"#/components/schemas/level3"},"partial-authorization":{"type":"boolean","description":"Indicates if partial authorization was allowed."},"partial-approved":{"type":"boolean","description":"Indicates if the transaction was partially approved."},"additional-amounts":{"type":"array","description":"List of additional amounts applied to the transaction.","xml":{"wrapped":true},"items":{"$ref":"#/components/schemas/additional-amount"}},"secure3d-eci":{"type":"string","description":"Electronic Commerce Indicator for 3D Secure."},"secure3d-result-code":{"type":"string","description":"Result code from 3D Secure authentication."},"total-amount":{"type":"string","description":"Total amount including all charges."},"processing-party-reference":{"type":"string","description":"Reference ID from the processing party."},"original-processing-party-reference":{"type":"string","description":"Reference of the original transaction assigned by the processing party."},"external-transaction-reference":{"type":"string","description":"External reference ID for the transaction."},"funding-reference":{"type":"string","description":"Reference for the funding transaction."},"token-id":{"type":"string","description":"Identifier of the payment token."},"network-transaction-reference":{"type":"string","description":"Reference ID from the payment network for the transaction."},"create-token":{"type":"boolean","description":"Indicates if a token should be created for the transaction."},"moto":{"type":"boolean","description":"Indicates whether the transaction is MOTO."},"issuer_id":{"type":"string","description":"Identifier for the card issuer."},"digital-wallet-type":{"type":"string","description":"Type of digital wallet used. For example, GOOGLE."}},"description":"Contains all details related to the authorized transaction.","xml":{"name":"transaction"}},"action":{"type":"object","properties":{"url":{"type":"string","description":"URL endpoint used for the transaction."},"method":{"type":"string","description":"Method used for the transaction. For example, POST, GET."},"type":{"type":"string","description":"Type of transaction. For example, SALE."},"environment":{"type":"string","description":"Environment in which the transaction was processed. For example, production, test."},"locale":{"type":"string","description":"Locale setting used during the transaction."},"data":{"type":"object","additionalProperties":{"type":"string","description":"Additional data properties related to the action."},"description":"Additional data properties related to the action."},"payment-method-type":{"type":"string","description":"Type of payment method used. For example, card, wallet."},"sub-type":{"type":"string","description":"Sub-category of the transaction type."},"client-key":{"type":"string","description":"Key identifying the client initiating the transaction."},"qr-code-data":{"type":"string","description":"Data encoded in the QR code for the transaction."}},"description":"The transaction action performed.","xml":{"name":"action"}},"emv":{"type":"object","properties":{"application-name":{"type":"string","description":"The name of the EMV application used to process the transaction."},"application-id":{"type":"string","description":"The unique identifier of the application."},"terminal-verification-results":{"type":"string","description":"Results of terminal-level verification during the transaction."},"transaction-status-information":{"type":"string","description":"Status details that describes the processing state of the transaction."},"iad":{"type":"string","description":"IAD provided by the card issuer during the authorization."},"transaction-certificate":{"type":"string","description":"A certificate generated during the transaction processing."},"application-transaction-counter":{"type":"string","description":"A counter that increments with each transaction."}},"description":"EMV chip data related to the transaction.","xml":{"name":"emv"}},"additional-amount":{"type":"object","properties":{"amount":{"type":"string","description":"Amount of transaction."},"account-type":{"type":"string","description":"Account type of transaction."},"amount-type":{"type":"string","description":"Refers to amount type of transaction."}},"description":"List of additional amounts applied to the transaction.","xml":{"name":"additional-amount"}},"ErrorPayloadResponsePayload":{"type":"object","properties":{"error":{"$ref":"#/components/schemas/ErrorPayload"},"payloadType":{"type":"string","description":"Type of payload returned in the response.","xml":{"name":"type","attribute":true}}},"description":"Payload","xml":{"name":"payload"}},"ErrorPayload":{"type":"object","properties":{"error-message":{"type":"string","description":"Describes the reason for the error."},"result-code":{"type":"string","description":"Numeric code that identifies the type of error returned by the request."},"time-stamp":{"type":"string","description":"Date and time when the error occurred, ISO 8601 format (UTC)."}},"xml":{"name":"error"}}}}}
```

## Start sale transaction

> Start sale transactions of $1 or more. Transactions below $1 are automatically declined during testing. Find the approved sale transactions in the Open batch to settle them.

```json
{"openapi":"3.0.1","info":{"title":"Transaction Service API","version":"2.0"},"paths":{"/rest/v2/transactions/sale":{"post":{"tags":["Transactions"],"summary":"Start sale transaction","description":"Start sale transactions of $1 or more. Transactions below $1 are automatically declined during testing. Find the approved sale transactions in the Open batch to settle them.","operationId":"doSaleTransaction","parameters":[{"name":"api-key","in":"header","description":"An access API key issued to you by Xplor Pay.","required":true,"schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Request"}}},"required":true},"responses":{"200":{"description":"Successful Transaction","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ClearentTransactionResponsePayload"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ClearentTransactionResponsePayload"}}}},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}}}},"402":{"description":"Business Exception","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}}}},"500":{"description":"Internal server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}}}}}}}},"components":{"schemas":{"Request":{"required":["add-tax-to-amount","amount","secure3d","secure3d-directory-server-transaction-id","secure3d-eci","secure3d-platform","secure3d-protocol-version","type"],"type":"object","properties":{"amount":{"type":"string","description":"Total transaction amount.","enum":["range[-infinity, 12]"]},"type":{"type":"string","description":"Transaction type to process. For example, SALE, AUTH, REFUND.","enum":["AUTH,SALE,REFUND,VOID,CAPTURE,FORCED SALE,CARD INQUIRY"]},"card":{"type":"string","description":"Card number or payment token."},"secure3d":{"type":"string","description":"3‑D Secure cryptogram or CAVV (Cardholder Authentication Verification Value) provided by the 3DS provider.","enum":["range[-infinity, 40]"]},"secure3d-eci":{"type":"string","description":"Electronic Commerce Indicator from the issuer.","enum":["range[-infinity, 2]"]},"secure3d-platform":{"type":"string","description":"Name of the platform or provider used to perform 3‑D Secure (3DS) authentication."},"secure3d-directory-server-transaction-id":{"type":"string","description":"Directory Server Transaction ID that ties the authentication to the transaction authorization."},"secure3d-protocol-version":{"type":"string","description":"3‑D Secure protocol version used to ensure correct liability and routing."},"id":{"type":"string","description":"Transaction identifier from a previous sale or authorization.","enum":["range[-infinity, 19]"]},"billing":{"$ref":"#/components/schemas/Address"},"shipping":{"$ref":"#/components/schemas/Address"},"csc":{"type":"string","description":"Card security code."},"comments":{"type":"string","description":"Additional notes for the transaction.","enum":["range[-infinity, 225]"]},"cvm":{"type":"string","description":"Cardholder verification method.","enum":["NON (None),MSG(Manual Signature),OFC(Offline Pin in the Clear),PIN(Online Pin),OFE(Offline Encrypted Pin)"]},"exp-date":{"type":"string","description":"Card expiration date in MMyy format."},"track2-data":{"type":"string","description":"Clear-text Track 2 data."},"encrypted-track-data":{"type":"string","description":"Encrypted track data; requires track-format."},"track-format":{"type":"string","description":"Format of encrypted track data.","enum":["MAGTEK,IDTECH,DEJAVOO,PAX"]},"tip-amount":{"type":"string","description":"Tip amount applied to the transaction.","enum":["range[-infinity, 12]"]},"invoice":{"type":"string","description":"Merchant-defined invoice number."},"authorization-code":{"type":"string","description":"Authorization code for a forced sale obtained from an external processor.","enum":["range[-infinity, 255]"]},"purchase-order":{"type":"string","description":"Merchant-defined purchase order number.","enum":["range[-infinity, 255]"]},"email-receipt":{"type":"string","description":"Indicates whether to send an email receipt to the customer."},"email-address":{"type":"string","description":"The customer's email address.","enum":["range[-infinity, 255]"]},"customer-id":{"type":"string","description":"Merchant-defined customer identifier.","enum":["range[-infinity, 255]"]},"order-id":{"type":"string","description":"Merchant-defined order identifier.","enum":["range[-infinity, 255]"]},"description":{"type":"string","description":"Description of the transaction.","enum":["range[-infinity, 255]"]},"client-ip":{"type":"string","description":"IP address where the request originated.","enum":["range[-infinity, 255]"]},"billing-is-shipping":{"type":"string","description":"Indicates whether billing and shipping addresses match."},"create-token":{"type":"string","description":"Creates a payment token during the transaction."},"merchant-legacy-token":{"type":"string","description":"Indicates use of a legacy payment token."},"token-description":{"type":"string","description":"Description for the created token.","enum":["range[-infinity, 255]"]},"card-type":{"type":"string","description":"Card brand when creating a token.","enum":["VISA,MASTERCARD,AMERICAN EXPRESS,DISCOVER,DINERS CLUB,JCB"]},"emv-data":{"type":"string","description":"EMV transaction data payload."},"key-serial-number":{"type":"string","description":"Key serial number for EMV encryption."},"emv-entry-method":{"type":"string","description":"Method used to capture EMV data.","enum":["EMV_DIP,EMV_CONTACTLESS,EMV_FALLBACK_SWIPE,EMV_FALLBACK_NONTECH"]},"software-type":{"type":"string","description":"Identifies the integrating application.","enum":["range[-infinity, 255]"]},"software-type-version":{"type":"string","description":"Version of the integrating application."},"pin-data":{"type":"string","description":"Encrypted PIN data for PIN-based transactions."},"contactless":{"type":"string","description":"Indicates contactless usage (full EMV only)."},"contactless-device":{"type":"string","description":"Indicates contactless device usage (full EMV only)."},"sales-tax-amount":{"type":"string","description":"Sales tax amount applied to the transaction.","enum":["range[-infinity, 12]"]},"sales-tax-type":{"type":"string","description":"Sales tax classification.","enum":["LOCAL_SALES_TAX,TAX_EXEMPT"]},"check-field":{"type":"string","description":"Field used for duplicate transaction checks.","enum":["range[-infinity, 15]"]},"service-fee":{"type":"string","description":"Service fee applied to the transaction.","enum":["range[-infinity, 12]"]},"check-field-mid":{"type":"boolean","description":"Enables merchant-level duplicate validation for EMV."},"platform-fees":{"type":"array","description":"Platform fees applied to the merchant.","items":{"$ref":"#/components/schemas/platform-fee"}},"is-amex":{"type":"boolean","description":"Indicates whether the card is American Express."},"is-sp30":{"type":"boolean","description":"Indicates whether the transaction is processed on an SP30 terminal."},"card-inquiry":{"type":"boolean","description":"Validates the card before token storage."},"level3":{"$ref":"#/components/schemas/level3"},"partial-authorization":{"type":"boolean","description":"Allows partial approval when full amount is unavailable."},"add-tax-to-amount":{"type":"boolean","description":"Indicates whether to add tax to the transaction amount."}},"xml":{"name":"transaction"}},"Address":{"type":"object","properties":{"company":{"type":"string","description":"The company name for the billing address."},"street":{"type":"string","description":"The primary street address."},"street2":{"type":"string","description":"Additional street information. For example, suite."},"city":{"type":"string","description":"The billing city."},"state":{"type":"string","description":"The state of the billing address."},"zip":{"type":"string","description":"The postal code of billing address."},"country":{"type":"string","description":"The country of the billing address."},"phone":{"type":"string","description":"The contact phone number."},"first-name":{"type":"string","description":"First name of the contact."},"last-name":{"type":"string","description":"Last name of the contact."},"from-zip":{"type":"string","description":"The originating ZIP code."}},"description":"Contains shipping address and contact information.","xml":{"name":"clearent-address"}},"platform-fee":{"type":"object","properties":{"fee-name":{"type":"string","description":"The name of the fee applied to the transaction.","enum":["DealManager","FillMyBook"]}},"description":"List of platform fees applied.","xml":{"name":"platform-fee"}},"level3":{"type":"object","properties":{"vat-tax-amount":{"type":"string","description":"The VAT amount applied to the transaction."},"vat-tax-rate":{"type":"string","description":"VAT tax rate applied to the transaction."},"order-date":{"type":"string","description":"The date when the order was created."},"customer-vat-registration-number":{"type":"string","description":"Cardholder's VAT registration number."},"summary-commodity-code":{"type":"string","description":"Code that identifies the type of service included in the transaction."},"discount-amount":{"type":"string","description":"Total discount amount."},"destination-country-code":{"type":"string","description":"The ISO country code of the destination."},"freight-amount":{"type":"string","description":"Freight charges."},"duty-amount":{"type":"string","description":"Duty amount applied."},"level3-items":{"$ref":"#/components/schemas/level3-items"}},"description":"Level 3 data for enhanced transaction details.","xml":{"name":"level3"}},"level3-items":{"type":"object","properties":{"level3-items":{"type":"array","items":{"$ref":"#/components/schemas/level3-item"}}},"description":"Level 3 line-item data for the transaction.","xml":{"name":"level3-items"}},"level3-item":{"type":"object","properties":{"item-description":{"type":"string","description":"Description of the item."},"item-commodity-code":{"type":"string","description":"Commodity code of the item."},"item-quantity":{"type":"string","description":"Quantity of items comprising of the order."},"item-unit-of-measure":{"type":"string","description":"The unit of measure of the purchased item as determined by ANSI X-12. Allowable Units of Measure and Codes."},"item-unit-cost":{"type":"string","description":"Per item cost for the order."},"item-product-code":{"type":"string","description":"Merchant identifiable code e.g., SKU or Model Number."},"item-tax-amount":{"type":"string","description":"Tax amount per item."},"item-tax-rate":{"type":"string","description":"Tax rate per item expressed as a decimal."},"item-discount":{"type":"string","description":"Discount amount applied per item."},"item-line-total":{"type":"string","description":"Total item count for the order."},"item-net-gross-ind":{"type":"string","description":"Indicated where the extended item amount is included in the tax. Can either be Yes (\"Y\") or No (\"N\") but should be passed as \"N\"."},"item-discount-rate":{"type":"string","description":"Discount rate applied per item expressed as a decimal."}},"description":"Level 3 line-item data for the transaction.","xml":{"name":"level3-item"}},"ClearentTransactionResponsePayload":{"type":"object","properties":{"transaction":{"$ref":"#/components/schemas/transaction"},"payloadType":{"type":"string","description":"Type of payload returned in the response.","xml":{"name":"type","attribute":true}}},"description":"payload","xml":{"name":"payload"}},"transaction":{"type":"object","properties":{"amount":{"type":"string","description":"Total value associated with the transaction."},"currency":{"type":"string","description":"Currency used for the transaction."},"id":{"type":"string","description":"Unique transaction ID."},"invoice":{"type":"string","description":"Invoice number associated with the transaction."},"description":{"type":"string","description":"Description of the transaction."},"comments":{"type":"string","description":"Comments associated with the transaction."},"serverId":{"type":"string","deprecated":true},"created":{"type":"string","description":"Date and time when the transaction was created."},"type":{"type":"string","description":"Identifies the transaction type.","enum":["AUTH","SALE","REFUND","VOID","CAPTURE","FORCED SALE","CARD INQUIRY"]},"result":{"type":"string","description":"Result of the transaction. For example, APPROVED.","enum":["APPROVED","DECLINED","ERROR"]},"billing":{"$ref":"#/components/schemas/Address"},"shipping":{"$ref":"#/components/schemas/Address"},"card":{"type":"string","description":"Card number used for the transaction."},"csc":{"type":"string","description":"Card Security Code used."},"cvm":{"type":"string","description":"Cardholder Verification Method used.","enum":["NON (None)","MSG(Manual Signature)","OFC(Offline Pin in the Clear)","PIN(Online Pin)","OFE(Offline Encrypted Pin)"]},"action":{"$ref":"#/components/schemas/action"},"authorization-code":{"type":"string","description":"Code indicating the transaction authorization."},"avs-result-code":{"type":"string","description":"Result code from Address Verification Service.","enum":["X","Y","A","W","Z","N","U","R","S","G"]},"avs-result-code-description":{"type":"string","description":"Description of the AVS result."},"csc-result-code":{"type":"string","description":"Result code from CSC verification.","enum":["M","N","P","S","U","X"]},"csc-result-code-description":{"type":"string","description":"Description of the CSC result."},"tip-adjusted-amount":{"type":"string","description":"Amount of the adjusted tip."},"avs-street":{"type":"string","description":"Street used in AVS check."},"avs-zip":{"type":"string","description":"ZIP code used in AVS check."},"token-description":{"type":"string","description":"Description of the token created."},"original-amount":{"type":"string","description":"Original amount before adjustments."},"tip-amount":{"type":"string","description":"Tip amount included in the transaction."},"ref-id":{"type":"string","description":"Reference ID for the transaction."},"entry-method":{"type":"string","description":"Method used to enter payment data of the transaction. For example, Swipe/Manual."},"first-recurring-transaction":{"type":"string","description":"Indicates whether this is the first recurring transaction."},"batch-string-id":{"type":"string","description":"Identifies the settlement batch ID."},"order-id":{"type":"string","description":"Order id passed in with the transaction."},"purchase-order":{"type":"string","description":"Purchase order number."},"customer-id":{"type":"string","description":"Customer id passed in with the transaction."},"email-address":{"type":"string","description":"Email address associated with the transaction."},"display-message":{"type":"string","description":"Displayable message about transaction result."},"result-code":{"type":"string","description":"Result code associated with transaction result."},"billing-is-shipping":{"type":"string","description":"Indicates if billing and shipping addresses are the same."},"tip-adjusted":{"type":"string","description":"Indicates if the tip was adjusted."},"exp-date":{"type":"string","description":"Expiration date of the card."},"client-ip":{"type":"string","description":"IP address of the client initiating the transaction."},"voided":{"type":"string","description":"Indicates if the transaction was voided."},"pending":{"type":"string","description":"Indicates if the transaction is pending."},"voided-auth":{"type":"string","description":"Indicates if the authorization was voided."},"settled":{"type":"string","description":"Indicates if the transaction has been settled."},"status":{"type":"string","description":"Status of the transaction. For example, approved."},"emv-data":{"type":"string","description":"Raw EMV data string."},"key-serial-number":{"type":"string","description":"Serial number of the encryption key used."},"emv-entry-method":{"type":"string","description":"Method used to enter EMV data.","enum":["EMV_DIP","EMV_CONTACTLESS","EMV_FALLBACK_SWIPE","EMV_FALLBACK_NONTECH"]},"software-type":{"type":"string","description":"Type of software used for the transaction."},"customer-first-name":{"type":"string","description":"First name of the customer."},"customer-last-name":{"type":"string","description":"Last name of the customer."},"plan-name":{"type":"string","description":"Name of the payment plan used."},"card-type":{"type":"string","description":"Type of card used. For example, VISA."},"contactless":{"type":"string","description":"Indicates if contactless payment was used."},"contactless-device":{"type":"string","description":"Indicates if a contactless device was used."},"sales-tax-type":{"type":"string","description":"Type of sales tax applied."},"sales-tax-amount":{"type":"string","description":"Amount of sales tax applied."},"add-tax-to-amount":{"type":"boolean","description":"Indicates if tax was added to the transaction amount."},"emv-data-response":{"type":"string","description":"Response data from EMV processing."},"emv":{"$ref":"#/components/schemas/emv"},"signature-base-64-image":{"type":"string","description":"Base64-encoded image of the signature."},"last-four":{"type":"string","description":"Last four digits of the card number."},"check-field-duplicate":{"type":"boolean","description":"Indicates if a duplicate check was performed."},"service-fee":{"type":"string","description":"Service fee applied to the transaction"},"base-amount":{"type":"string","description":"Base amount before taxes and fees."},"platform-fees":{"type":"array","description":"List of platform fees applied.","items":{"$ref":"#/components/schemas/platform-fee"}},"merchant-id":{"type":"string","description":"Identifier for the merchant."},"terminal-id":{"type":"string","description":"Identifier for the terminal used."},"surcharge-applied":{"type":"boolean","description":"Indicates if a surcharge was applied."},"level3":{"$ref":"#/components/schemas/level3"},"partial-authorization":{"type":"boolean","description":"Indicates if partial authorization was allowed."},"partial-approved":{"type":"boolean","description":"Indicates if the transaction was partially approved."},"additional-amounts":{"type":"array","description":"List of additional amounts applied to the transaction.","xml":{"wrapped":true},"items":{"$ref":"#/components/schemas/additional-amount"}},"secure3d-eci":{"type":"string","description":"Electronic Commerce Indicator for 3D Secure."},"secure3d-result-code":{"type":"string","description":"Result code from 3D Secure authentication."},"total-amount":{"type":"string","description":"Total amount including all charges."},"processing-party-reference":{"type":"string","description":"Reference ID from the processing party."},"original-processing-party-reference":{"type":"string","description":"Reference of the original transaction assigned by the processing party."},"external-transaction-reference":{"type":"string","description":"External reference ID for the transaction."},"funding-reference":{"type":"string","description":"Reference for the funding transaction."},"token-id":{"type":"string","description":"Identifier of the payment token."},"network-transaction-reference":{"type":"string","description":"Reference ID from the payment network for the transaction."},"create-token":{"type":"boolean","description":"Indicates if a token should be created for the transaction."},"moto":{"type":"boolean","description":"Indicates whether the transaction is MOTO."},"issuer_id":{"type":"string","description":"Identifier for the card issuer."},"digital-wallet-type":{"type":"string","description":"Type of digital wallet used. For example, GOOGLE."}},"description":"Contains all details related to the authorized transaction.","xml":{"name":"transaction"}},"action":{"type":"object","properties":{"url":{"type":"string","description":"URL endpoint used for the transaction."},"method":{"type":"string","description":"Method used for the transaction. For example, POST, GET."},"type":{"type":"string","description":"Type of transaction. For example, SALE."},"environment":{"type":"string","description":"Environment in which the transaction was processed. For example, production, test."},"locale":{"type":"string","description":"Locale setting used during the transaction."},"data":{"type":"object","additionalProperties":{"type":"string","description":"Additional data properties related to the action."},"description":"Additional data properties related to the action."},"payment-method-type":{"type":"string","description":"Type of payment method used. For example, card, wallet."},"sub-type":{"type":"string","description":"Sub-category of the transaction type."},"client-key":{"type":"string","description":"Key identifying the client initiating the transaction."},"qr-code-data":{"type":"string","description":"Data encoded in the QR code for the transaction."}},"description":"The transaction action performed.","xml":{"name":"action"}},"emv":{"type":"object","properties":{"application-name":{"type":"string","description":"The name of the EMV application used to process the transaction."},"application-id":{"type":"string","description":"The unique identifier of the application."},"terminal-verification-results":{"type":"string","description":"Results of terminal-level verification during the transaction."},"transaction-status-information":{"type":"string","description":"Status details that describes the processing state of the transaction."},"iad":{"type":"string","description":"IAD provided by the card issuer during the authorization."},"transaction-certificate":{"type":"string","description":"A certificate generated during the transaction processing."},"application-transaction-counter":{"type":"string","description":"A counter that increments with each transaction."}},"description":"EMV chip data related to the transaction.","xml":{"name":"emv"}},"additional-amount":{"type":"object","properties":{"amount":{"type":"string","description":"Amount of transaction."},"account-type":{"type":"string","description":"Account type of transaction."},"amount-type":{"type":"string","description":"Refers to amount type of transaction."}},"description":"List of additional amounts applied to the transaction.","xml":{"name":"additional-amount"}},"ErrorPayloadResponsePayload":{"type":"object","properties":{"error":{"$ref":"#/components/schemas/ErrorPayload"},"payloadType":{"type":"string","description":"Type of payload returned in the response.","xml":{"name":"type","attribute":true}}},"description":"Payload","xml":{"name":"payload"}},"ErrorPayload":{"type":"object","properties":{"error-message":{"type":"string","description":"Describes the reason for the error."},"result-code":{"type":"string","description":"Numeric code that identifies the type of error returned by the request."},"time-stamp":{"type":"string","description":"Date and time when the error occurred, ISO 8601 format (UTC)."}},"xml":{"name":"error"}}}}}
```

## Refund transaction

> Refund an amount for a previously settled transaction. The refund process applies only to transactions that were settled using the sale and capture method.> \
> The following two options allow you to refund transactions:> \
> Matched refund: Use the ID and amount fields to process a matched refund for up to the total amount of the previous transaction.> \
> Unmatched refund: Use the card field to process an unmatched refund for an amount that is less than or greater than the total of the previous transaction.

```json
{"openapi":"3.0.1","info":{"title":"Transaction Service API","version":"2.0"},"paths":{"/rest/v2/transactions/refund":{"post":{"tags":["Transactions"],"summary":"Refund transaction","description":"Refund an amount for a previously settled transaction. The refund process applies only to transactions that were settled using the sale and capture method.\r\nThe following two options allow you to refund transactions:\r\nMatched refund: Use the ID and amount fields to process a matched refund for up to the total amount of the previous transaction.\r\nUnmatched refund: Use the card field to process an unmatched refund for an amount that is less than or greater than the total of the previous transaction.","operationId":"doRefundTransaction","parameters":[{"name":"api-key","in":"header","description":"An access API key issued to you by Xplor Pay.","required":true,"schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Request"}}},"required":true},"responses":{"200":{"description":"Successful Transaction","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ClearentTransactionResponsePayload"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ClearentTransactionResponsePayload"}}}},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}}}},"402":{"description":"Business Exception","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}}}},"500":{"description":"Internal server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}}}}}}}},"components":{"schemas":{"Request":{"required":["add-tax-to-amount","amount","secure3d","secure3d-directory-server-transaction-id","secure3d-eci","secure3d-platform","secure3d-protocol-version","type"],"type":"object","properties":{"amount":{"type":"string","description":"Total transaction amount.","enum":["range[-infinity, 12]"]},"type":{"type":"string","description":"Transaction type to process. For example, SALE, AUTH, REFUND.","enum":["AUTH,SALE,REFUND,VOID,CAPTURE,FORCED SALE,CARD INQUIRY"]},"card":{"type":"string","description":"Card number or payment token."},"secure3d":{"type":"string","description":"3‑D Secure cryptogram or CAVV (Cardholder Authentication Verification Value) provided by the 3DS provider.","enum":["range[-infinity, 40]"]},"secure3d-eci":{"type":"string","description":"Electronic Commerce Indicator from the issuer.","enum":["range[-infinity, 2]"]},"secure3d-platform":{"type":"string","description":"Name of the platform or provider used to perform 3‑D Secure (3DS) authentication."},"secure3d-directory-server-transaction-id":{"type":"string","description":"Directory Server Transaction ID that ties the authentication to the transaction authorization."},"secure3d-protocol-version":{"type":"string","description":"3‑D Secure protocol version used to ensure correct liability and routing."},"id":{"type":"string","description":"Transaction identifier from a previous sale or authorization.","enum":["range[-infinity, 19]"]},"billing":{"$ref":"#/components/schemas/Address"},"shipping":{"$ref":"#/components/schemas/Address"},"csc":{"type":"string","description":"Card security code."},"comments":{"type":"string","description":"Additional notes for the transaction.","enum":["range[-infinity, 225]"]},"cvm":{"type":"string","description":"Cardholder verification method.","enum":["NON (None),MSG(Manual Signature),OFC(Offline Pin in the Clear),PIN(Online Pin),OFE(Offline Encrypted Pin)"]},"exp-date":{"type":"string","description":"Card expiration date in MMyy format."},"track2-data":{"type":"string","description":"Clear-text Track 2 data."},"encrypted-track-data":{"type":"string","description":"Encrypted track data; requires track-format."},"track-format":{"type":"string","description":"Format of encrypted track data.","enum":["MAGTEK,IDTECH,DEJAVOO,PAX"]},"tip-amount":{"type":"string","description":"Tip amount applied to the transaction.","enum":["range[-infinity, 12]"]},"invoice":{"type":"string","description":"Merchant-defined invoice number."},"authorization-code":{"type":"string","description":"Authorization code for a forced sale obtained from an external processor.","enum":["range[-infinity, 255]"]},"purchase-order":{"type":"string","description":"Merchant-defined purchase order number.","enum":["range[-infinity, 255]"]},"email-receipt":{"type":"string","description":"Indicates whether to send an email receipt to the customer."},"email-address":{"type":"string","description":"The customer's email address.","enum":["range[-infinity, 255]"]},"customer-id":{"type":"string","description":"Merchant-defined customer identifier.","enum":["range[-infinity, 255]"]},"order-id":{"type":"string","description":"Merchant-defined order identifier.","enum":["range[-infinity, 255]"]},"description":{"type":"string","description":"Description of the transaction.","enum":["range[-infinity, 255]"]},"client-ip":{"type":"string","description":"IP address where the request originated.","enum":["range[-infinity, 255]"]},"billing-is-shipping":{"type":"string","description":"Indicates whether billing and shipping addresses match."},"create-token":{"type":"string","description":"Creates a payment token during the transaction."},"merchant-legacy-token":{"type":"string","description":"Indicates use of a legacy payment token."},"token-description":{"type":"string","description":"Description for the created token.","enum":["range[-infinity, 255]"]},"card-type":{"type":"string","description":"Card brand when creating a token.","enum":["VISA,MASTERCARD,AMERICAN EXPRESS,DISCOVER,DINERS CLUB,JCB"]},"emv-data":{"type":"string","description":"EMV transaction data payload."},"key-serial-number":{"type":"string","description":"Key serial number for EMV encryption."},"emv-entry-method":{"type":"string","description":"Method used to capture EMV data.","enum":["EMV_DIP,EMV_CONTACTLESS,EMV_FALLBACK_SWIPE,EMV_FALLBACK_NONTECH"]},"software-type":{"type":"string","description":"Identifies the integrating application.","enum":["range[-infinity, 255]"]},"software-type-version":{"type":"string","description":"Version of the integrating application."},"pin-data":{"type":"string","description":"Encrypted PIN data for PIN-based transactions."},"contactless":{"type":"string","description":"Indicates contactless usage (full EMV only)."},"contactless-device":{"type":"string","description":"Indicates contactless device usage (full EMV only)."},"sales-tax-amount":{"type":"string","description":"Sales tax amount applied to the transaction.","enum":["range[-infinity, 12]"]},"sales-tax-type":{"type":"string","description":"Sales tax classification.","enum":["LOCAL_SALES_TAX,TAX_EXEMPT"]},"check-field":{"type":"string","description":"Field used for duplicate transaction checks.","enum":["range[-infinity, 15]"]},"service-fee":{"type":"string","description":"Service fee applied to the transaction.","enum":["range[-infinity, 12]"]},"check-field-mid":{"type":"boolean","description":"Enables merchant-level duplicate validation for EMV."},"platform-fees":{"type":"array","description":"Platform fees applied to the merchant.","items":{"$ref":"#/components/schemas/platform-fee"}},"is-amex":{"type":"boolean","description":"Indicates whether the card is American Express."},"is-sp30":{"type":"boolean","description":"Indicates whether the transaction is processed on an SP30 terminal."},"card-inquiry":{"type":"boolean","description":"Validates the card before token storage."},"level3":{"$ref":"#/components/schemas/level3"},"partial-authorization":{"type":"boolean","description":"Allows partial approval when full amount is unavailable."},"add-tax-to-amount":{"type":"boolean","description":"Indicates whether to add tax to the transaction amount."}},"xml":{"name":"transaction"}},"Address":{"type":"object","properties":{"company":{"type":"string","description":"The company name for the billing address."},"street":{"type":"string","description":"The primary street address."},"street2":{"type":"string","description":"Additional street information. For example, suite."},"city":{"type":"string","description":"The billing city."},"state":{"type":"string","description":"The state of the billing address."},"zip":{"type":"string","description":"The postal code of billing address."},"country":{"type":"string","description":"The country of the billing address."},"phone":{"type":"string","description":"The contact phone number."},"first-name":{"type":"string","description":"First name of the contact."},"last-name":{"type":"string","description":"Last name of the contact."},"from-zip":{"type":"string","description":"The originating ZIP code."}},"description":"Contains shipping address and contact information.","xml":{"name":"clearent-address"}},"platform-fee":{"type":"object","properties":{"fee-name":{"type":"string","description":"The name of the fee applied to the transaction.","enum":["DealManager","FillMyBook"]}},"description":"List of platform fees applied.","xml":{"name":"platform-fee"}},"level3":{"type":"object","properties":{"vat-tax-amount":{"type":"string","description":"The VAT amount applied to the transaction."},"vat-tax-rate":{"type":"string","description":"VAT tax rate applied to the transaction."},"order-date":{"type":"string","description":"The date when the order was created."},"customer-vat-registration-number":{"type":"string","description":"Cardholder's VAT registration number."},"summary-commodity-code":{"type":"string","description":"Code that identifies the type of service included in the transaction."},"discount-amount":{"type":"string","description":"Total discount amount."},"destination-country-code":{"type":"string","description":"The ISO country code of the destination."},"freight-amount":{"type":"string","description":"Freight charges."},"duty-amount":{"type":"string","description":"Duty amount applied."},"level3-items":{"$ref":"#/components/schemas/level3-items"}},"description":"Level 3 data for enhanced transaction details.","xml":{"name":"level3"}},"level3-items":{"type":"object","properties":{"level3-items":{"type":"array","items":{"$ref":"#/components/schemas/level3-item"}}},"description":"Level 3 line-item data for the transaction.","xml":{"name":"level3-items"}},"level3-item":{"type":"object","properties":{"item-description":{"type":"string","description":"Description of the item."},"item-commodity-code":{"type":"string","description":"Commodity code of the item."},"item-quantity":{"type":"string","description":"Quantity of items comprising of the order."},"item-unit-of-measure":{"type":"string","description":"The unit of measure of the purchased item as determined by ANSI X-12. Allowable Units of Measure and Codes."},"item-unit-cost":{"type":"string","description":"Per item cost for the order."},"item-product-code":{"type":"string","description":"Merchant identifiable code e.g., SKU or Model Number."},"item-tax-amount":{"type":"string","description":"Tax amount per item."},"item-tax-rate":{"type":"string","description":"Tax rate per item expressed as a decimal."},"item-discount":{"type":"string","description":"Discount amount applied per item."},"item-line-total":{"type":"string","description":"Total item count for the order."},"item-net-gross-ind":{"type":"string","description":"Indicated where the extended item amount is included in the tax. Can either be Yes (\"Y\") or No (\"N\") but should be passed as \"N\"."},"item-discount-rate":{"type":"string","description":"Discount rate applied per item expressed as a decimal."}},"description":"Level 3 line-item data for the transaction.","xml":{"name":"level3-item"}},"ClearentTransactionResponsePayload":{"type":"object","properties":{"transaction":{"$ref":"#/components/schemas/transaction"},"payloadType":{"type":"string","description":"Type of payload returned in the response.","xml":{"name":"type","attribute":true}}},"description":"payload","xml":{"name":"payload"}},"transaction":{"type":"object","properties":{"amount":{"type":"string","description":"Total value associated with the transaction."},"currency":{"type":"string","description":"Currency used for the transaction."},"id":{"type":"string","description":"Unique transaction ID."},"invoice":{"type":"string","description":"Invoice number associated with the transaction."},"description":{"type":"string","description":"Description of the transaction."},"comments":{"type":"string","description":"Comments associated with the transaction."},"serverId":{"type":"string","deprecated":true},"created":{"type":"string","description":"Date and time when the transaction was created."},"type":{"type":"string","description":"Identifies the transaction type.","enum":["AUTH","SALE","REFUND","VOID","CAPTURE","FORCED SALE","CARD INQUIRY"]},"result":{"type":"string","description":"Result of the transaction. For example, APPROVED.","enum":["APPROVED","DECLINED","ERROR"]},"billing":{"$ref":"#/components/schemas/Address"},"shipping":{"$ref":"#/components/schemas/Address"},"card":{"type":"string","description":"Card number used for the transaction."},"csc":{"type":"string","description":"Card Security Code used."},"cvm":{"type":"string","description":"Cardholder Verification Method used.","enum":["NON (None)","MSG(Manual Signature)","OFC(Offline Pin in the Clear)","PIN(Online Pin)","OFE(Offline Encrypted Pin)"]},"action":{"$ref":"#/components/schemas/action"},"authorization-code":{"type":"string","description":"Code indicating the transaction authorization."},"avs-result-code":{"type":"string","description":"Result code from Address Verification Service.","enum":["X","Y","A","W","Z","N","U","R","S","G"]},"avs-result-code-description":{"type":"string","description":"Description of the AVS result."},"csc-result-code":{"type":"string","description":"Result code from CSC verification.","enum":["M","N","P","S","U","X"]},"csc-result-code-description":{"type":"string","description":"Description of the CSC result."},"tip-adjusted-amount":{"type":"string","description":"Amount of the adjusted tip."},"avs-street":{"type":"string","description":"Street used in AVS check."},"avs-zip":{"type":"string","description":"ZIP code used in AVS check."},"token-description":{"type":"string","description":"Description of the token created."},"original-amount":{"type":"string","description":"Original amount before adjustments."},"tip-amount":{"type":"string","description":"Tip amount included in the transaction."},"ref-id":{"type":"string","description":"Reference ID for the transaction."},"entry-method":{"type":"string","description":"Method used to enter payment data of the transaction. For example, Swipe/Manual."},"first-recurring-transaction":{"type":"string","description":"Indicates whether this is the first recurring transaction."},"batch-string-id":{"type":"string","description":"Identifies the settlement batch ID."},"order-id":{"type":"string","description":"Order id passed in with the transaction."},"purchase-order":{"type":"string","description":"Purchase order number."},"customer-id":{"type":"string","description":"Customer id passed in with the transaction."},"email-address":{"type":"string","description":"Email address associated with the transaction."},"display-message":{"type":"string","description":"Displayable message about transaction result."},"result-code":{"type":"string","description":"Result code associated with transaction result."},"billing-is-shipping":{"type":"string","description":"Indicates if billing and shipping addresses are the same."},"tip-adjusted":{"type":"string","description":"Indicates if the tip was adjusted."},"exp-date":{"type":"string","description":"Expiration date of the card."},"client-ip":{"type":"string","description":"IP address of the client initiating the transaction."},"voided":{"type":"string","description":"Indicates if the transaction was voided."},"pending":{"type":"string","description":"Indicates if the transaction is pending."},"voided-auth":{"type":"string","description":"Indicates if the authorization was voided."},"settled":{"type":"string","description":"Indicates if the transaction has been settled."},"status":{"type":"string","description":"Status of the transaction. For example, approved."},"emv-data":{"type":"string","description":"Raw EMV data string."},"key-serial-number":{"type":"string","description":"Serial number of the encryption key used."},"emv-entry-method":{"type":"string","description":"Method used to enter EMV data.","enum":["EMV_DIP","EMV_CONTACTLESS","EMV_FALLBACK_SWIPE","EMV_FALLBACK_NONTECH"]},"software-type":{"type":"string","description":"Type of software used for the transaction."},"customer-first-name":{"type":"string","description":"First name of the customer."},"customer-last-name":{"type":"string","description":"Last name of the customer."},"plan-name":{"type":"string","description":"Name of the payment plan used."},"card-type":{"type":"string","description":"Type of card used. For example, VISA."},"contactless":{"type":"string","description":"Indicates if contactless payment was used."},"contactless-device":{"type":"string","description":"Indicates if a contactless device was used."},"sales-tax-type":{"type":"string","description":"Type of sales tax applied."},"sales-tax-amount":{"type":"string","description":"Amount of sales tax applied."},"add-tax-to-amount":{"type":"boolean","description":"Indicates if tax was added to the transaction amount."},"emv-data-response":{"type":"string","description":"Response data from EMV processing."},"emv":{"$ref":"#/components/schemas/emv"},"signature-base-64-image":{"type":"string","description":"Base64-encoded image of the signature."},"last-four":{"type":"string","description":"Last four digits of the card number."},"check-field-duplicate":{"type":"boolean","description":"Indicates if a duplicate check was performed."},"service-fee":{"type":"string","description":"Service fee applied to the transaction"},"base-amount":{"type":"string","description":"Base amount before taxes and fees."},"platform-fees":{"type":"array","description":"List of platform fees applied.","items":{"$ref":"#/components/schemas/platform-fee"}},"merchant-id":{"type":"string","description":"Identifier for the merchant."},"terminal-id":{"type":"string","description":"Identifier for the terminal used."},"surcharge-applied":{"type":"boolean","description":"Indicates if a surcharge was applied."},"level3":{"$ref":"#/components/schemas/level3"},"partial-authorization":{"type":"boolean","description":"Indicates if partial authorization was allowed."},"partial-approved":{"type":"boolean","description":"Indicates if the transaction was partially approved."},"additional-amounts":{"type":"array","description":"List of additional amounts applied to the transaction.","xml":{"wrapped":true},"items":{"$ref":"#/components/schemas/additional-amount"}},"secure3d-eci":{"type":"string","description":"Electronic Commerce Indicator for 3D Secure."},"secure3d-result-code":{"type":"string","description":"Result code from 3D Secure authentication."},"total-amount":{"type":"string","description":"Total amount including all charges."},"processing-party-reference":{"type":"string","description":"Reference ID from the processing party."},"original-processing-party-reference":{"type":"string","description":"Reference of the original transaction assigned by the processing party."},"external-transaction-reference":{"type":"string","description":"External reference ID for the transaction."},"funding-reference":{"type":"string","description":"Reference for the funding transaction."},"token-id":{"type":"string","description":"Identifier of the payment token."},"network-transaction-reference":{"type":"string","description":"Reference ID from the payment network for the transaction."},"create-token":{"type":"boolean","description":"Indicates if a token should be created for the transaction."},"moto":{"type":"boolean","description":"Indicates whether the transaction is MOTO."},"issuer_id":{"type":"string","description":"Identifier for the card issuer."},"digital-wallet-type":{"type":"string","description":"Type of digital wallet used. For example, GOOGLE."}},"description":"Contains all details related to the authorized transaction.","xml":{"name":"transaction"}},"action":{"type":"object","properties":{"url":{"type":"string","description":"URL endpoint used for the transaction."},"method":{"type":"string","description":"Method used for the transaction. For example, POST, GET."},"type":{"type":"string","description":"Type of transaction. For example, SALE."},"environment":{"type":"string","description":"Environment in which the transaction was processed. For example, production, test."},"locale":{"type":"string","description":"Locale setting used during the transaction."},"data":{"type":"object","additionalProperties":{"type":"string","description":"Additional data properties related to the action."},"description":"Additional data properties related to the action."},"payment-method-type":{"type":"string","description":"Type of payment method used. For example, card, wallet."},"sub-type":{"type":"string","description":"Sub-category of the transaction type."},"client-key":{"type":"string","description":"Key identifying the client initiating the transaction."},"qr-code-data":{"type":"string","description":"Data encoded in the QR code for the transaction."}},"description":"The transaction action performed.","xml":{"name":"action"}},"emv":{"type":"object","properties":{"application-name":{"type":"string","description":"The name of the EMV application used to process the transaction."},"application-id":{"type":"string","description":"The unique identifier of the application."},"terminal-verification-results":{"type":"string","description":"Results of terminal-level verification during the transaction."},"transaction-status-information":{"type":"string","description":"Status details that describes the processing state of the transaction."},"iad":{"type":"string","description":"IAD provided by the card issuer during the authorization."},"transaction-certificate":{"type":"string","description":"A certificate generated during the transaction processing."},"application-transaction-counter":{"type":"string","description":"A counter that increments with each transaction."}},"description":"EMV chip data related to the transaction.","xml":{"name":"emv"}},"additional-amount":{"type":"object","properties":{"amount":{"type":"string","description":"Amount of transaction."},"account-type":{"type":"string","description":"Account type of transaction."},"amount-type":{"type":"string","description":"Refers to amount type of transaction."}},"description":"List of additional amounts applied to the transaction.","xml":{"name":"additional-amount"}},"ErrorPayloadResponsePayload":{"type":"object","properties":{"error":{"$ref":"#/components/schemas/ErrorPayload"},"payloadType":{"type":"string","description":"Type of payload returned in the response.","xml":{"name":"type","attribute":true}}},"description":"Payload","xml":{"name":"payload"}},"ErrorPayload":{"type":"object","properties":{"error-message":{"type":"string","description":"Describes the reason for the error."},"result-code":{"type":"string","description":"Numeric code that identifies the type of error returned by the request."},"time-stamp":{"type":"string","description":"Date and time when the error occurred, ISO 8601 format (UTC)."}},"xml":{"name":"error"}}}}}
```

## Process forced sale transaction

> Process forced sale transactions of $1 or more without prior authorization. Forced sale transactions under $1 are declined during testing.

```json
{"openapi":"3.0.1","info":{"title":"Transaction Service API","version":"2.0"},"paths":{"/rest/v2/transactions/forced-sale":{"post":{"tags":["Transactions"],"summary":"Process forced sale transaction","description":"Process forced sale transactions of $1 or more without prior authorization. Forced sale transactions under $1 are declined during testing.","operationId":"forcedSale","parameters":[{"name":"api-key","in":"header","description":"An access API key issued to you by Xplor Pay.","required":true,"schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Request"}}},"required":true},"responses":{"200":{"description":"Successful Transaction","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ClearentTransactionResponsePayload"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ClearentTransactionResponsePayload"}}}},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}}}},"402":{"description":"Business Exception","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}}}},"500":{"description":"Internal server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorPayloadResponsePayload"}}}}}}}},"components":{"schemas":{"Request":{"required":["add-tax-to-amount","amount","secure3d","secure3d-directory-server-transaction-id","secure3d-eci","secure3d-platform","secure3d-protocol-version","type"],"type":"object","properties":{"amount":{"type":"string","description":"Total transaction amount.","enum":["range[-infinity, 12]"]},"type":{"type":"string","description":"Transaction type to process. For example, SALE, AUTH, REFUND.","enum":["AUTH,SALE,REFUND,VOID,CAPTURE,FORCED SALE,CARD INQUIRY"]},"card":{"type":"string","description":"Card number or payment token."},"secure3d":{"type":"string","description":"3‑D Secure cryptogram or CAVV (Cardholder Authentication Verification Value) provided by the 3DS provider.","enum":["range[-infinity, 40]"]},"secure3d-eci":{"type":"string","description":"Electronic Commerce Indicator from the issuer.","enum":["range[-infinity, 2]"]},"secure3d-platform":{"type":"string","description":"Name of the platform or provider used to perform 3‑D Secure (3DS) authentication."},"secure3d-directory-server-transaction-id":{"type":"string","description":"Directory Server Transaction ID that ties the authentication to the transaction authorization."},"secure3d-protocol-version":{"type":"string","description":"3‑D Secure protocol version used to ensure correct liability and routing."},"id":{"type":"string","description":"Transaction identifier from a previous sale or authorization.","enum":["range[-infinity, 19]"]},"billing":{"$ref":"#/components/schemas/Address"},"shipping":{"$ref":"#/components/schemas/Address"},"csc":{"type":"string","description":"Card security code."},"comments":{"type":"string","description":"Additional notes for the transaction.","enum":["range[-infinity, 225]"]},"cvm":{"type":"string","description":"Cardholder verification method.","enum":["NON (None),MSG(Manual Signature),OFC(Offline Pin in the Clear),PIN(Online Pin),OFE(Offline Encrypted Pin)"]},"exp-date":{"type":"string","description":"Card expiration date in MMyy format."},"track2-data":{"type":"string","description":"Clear-text Track 2 data."},"encrypted-track-data":{"type":"string","description":"Encrypted track data; requires track-format."},"track-format":{"type":"string","description":"Format of encrypted track data.","enum":["MAGTEK,IDTECH,DEJAVOO,PAX"]},"tip-amount":{"type":"string","description":"Tip amount applied to the transaction.","enum":["range[-infinity, 12]"]},"invoice":{"type":"string","description":"Merchant-defined invoice number."},"authorization-code":{"type":"string","description":"Authorization code for a forced sale obtained from an external processor.","enum":["range[-infinity, 255]"]},"purchase-order":{"type":"string","description":"Merchant-defined purchase order number.","enum":["range[-infinity, 255]"]},"email-receipt":{"type":"string","description":"Indicates whether to send an email receipt to the customer."},"email-address":{"type":"string","description":"The customer's email address.","enum":["range[-infinity, 255]"]},"customer-id":{"type":"string","description":"Merchant-defined customer identifier.","enum":["range[-infinity, 255]"]},"order-id":{"type":"string","description":"Merchant-defined order identifier.","enum":["range[-infinity, 255]"]},"description":{"type":"string","description":"Description of the transaction.","enum":["range[-infinity, 255]"]},"client-ip":{"type":"string","description":"IP address where the request originated.","enum":["range[-infinity, 255]"]},"billing-is-shipping":{"type":"string","description":"Indicates whether billing and shipping addresses match."},"create-token":{"type":"string","description":"Creates a payment token during the transaction."},"merchant-legacy-token":{"type":"string","description":"Indicates use of a legacy payment token."},"token-description":{"type":"string","description":"Description for the created token.","enum":["range[-infinity, 255]"]},"card-type":{"type":"string","description":"Card brand when creating a token.","enum":["VISA,MASTERCARD,AMERICAN EXPRESS,DISCOVER,DINERS CLUB,JCB"]},"emv-data":{"type":"string","description":"EMV transaction data payload."},"key-serial-number":{"type":"string","description":"Key serial number for EMV encryption."},"emv-entry-method":{"type":"string","description":"Method used to capture EMV data.","enum":["EMV_DIP,EMV_CONTACTLESS,EMV_FALLBACK_SWIPE,EMV_FALLBACK_NONTECH"]},"software-type":{"type":"string","description":"Identifies the integrating application.","enum":["range[-infinity, 255]"]},"software-type-version":{"type":"string","description":"Version of the integrating application."},"pin-data":{"type":"string","description":"Encrypted PIN data for PIN-based transactions."},"contactless":{"type":"string","description":"Indicates contactless usage (full EMV only)."},"contactless-device":{"type":"string","description":"Indicates contactless device usage (full EMV only)."},"sales-tax-amount":{"type":"string","description":"Sales tax amount applied to the transaction.","enum":["range[-infinity, 12]"]},"sales-tax-type":{"type":"string","description":"Sales tax classification.","enum":["LOCAL_SALES_TAX,TAX_EXEMPT"]},"check-field":{"type":"string","description":"Field used for duplicate transaction checks.","enum":["range[-infinity, 15]"]},"service-fee":{"type":"string","description":"Service fee applied to the transaction.","enum":["range[-infinity, 12]"]},"check-field-mid":{"type":"boolean","description":"Enables merchant-level duplicate validation for EMV."},"platform-fees":{"type":"array","description":"Platform fees applied to the merchant.","items":{"$ref":"#/components/schemas/platform-fee"}},"is-amex":{"type":"boolean","description":"Indicates whether the card is American Express."},"is-sp30":{"type":"boolean","description":"Indicates whether the transaction is processed on an SP30 terminal."},"card-inquiry":{"type":"boolean","description":"Validates the card before token storage."},"level3":{"$ref":"#/components/schemas/level3"},"partial-authorization":{"type":"boolean","description":"Allows partial approval when full amount is unavailable."},"add-tax-to-amount":{"type":"boolean","description":"Indicates whether to add tax to the transaction amount."}},"xml":{"name":"transaction"}},"Address":{"type":"object","properties":{"company":{"type":"string","description":"The company name for the billing address."},"street":{"type":"string","description":"The primary street address."},"street2":{"type":"string","description":"Additional street information. For example, suite."},"city":{"type":"string","description":"The billing city."},"state":{"type":"string","description":"The state of the billing address."},"zip":{"type":"string","description":"The postal code of billing address."},"country":{"type":"string","description":"The country of the billing address."},"phone":{"type":"string","description":"The contact phone number."},"first-name":{"type":"string","description":"First name of the contact."},"last-name":{"type":"string","description":"Last name of the contact."},"from-zip":{"type":"string","description":"The originating ZIP code."}},"description":"Contains shipping address and contact information.","xml":{"name":"clearent-address"}},"platform-fee":{"type":"object","properties":{"fee-name":{"type":"string","description":"The name of the fee applied to the transaction.","enum":["DealManager","FillMyBo
[...]
